"
 Copyright (c) 2007-2010 Jan Vrany
 Copyright (c) 2009-2010 eXept Software AG

 Permission is hereby granted, free of charge, to any person
 obtaining a copy of this software and associated documentation
 files (the 'Software'), to deal in the Software without
 restriction, including without limitation the rights to use,
 copy, modify, merge, publish, distribute, sublicense, and/or sell
 copies of the Software, and to permit persons to whom the
 Software is furnished to do so, subject to the following
 conditions:

 The above copyright notice and this permission notice shall be
 included in all copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND,
 EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
 OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
 HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
 WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
 OTHER DEALINGS IN THE SOFTWARE.
"
"{ Package: 'stx:libsvn' }"

LibraryDefinition subclass:#stx_libsvn
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'* Projects & Packages *'
!

!stx_libsvn class methodsFor:'documentation'!

copyright
"
 Copyright (c) 2007-2010 Jan Vrany
 Copyright (c) 2009-2010 eXept Software AG

 Permission is hereby granted, free of charge, to any person
 obtaining a copy of this software and associated documentation
 files (the 'Software'), to deal in the Software without
 restriction, including without limitation the rights to use,
 copy, modify, merge, publish, distribute, sublicense, and/or sell
 copies of the Software, and to permit persons to whom the
 Software is furnished to do so, subject to the following
 conditions:

 The above copyright notice and this permission notice shall be
 included in all copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND,
 EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
 OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
 HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
 WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
 OTHER DEALINGS IN THE SOFTWARE.

"
!

extensionsVersion_CVS
    ^ '$Header$'

! !

!stx_libsvn class methodsFor:'description'!

excludedFromPreRequisites
    "list all packages which should be ignored in the automatic
     preRequisites scan. See #preRequisites for more."

    ^ #(
    )
!

postLoadAction

	SVN::Configuration flushCaches.
	SVN::RepositoryManager reset.

    "/JV-2011-06-10: Not needed anymore since new version of St/X now supports multiple
    "/VCS...
    "
    NewLauncher
	addSettingsApplicationByClass: SVN::ConfigurationApp fullName asSymbol
	withName:'Subversion'
	icon: nil.
    "

    "Autoload tests"
    Smalltalk isStandAloneApp ifTrue:[^self].
    self classes do: [:cls|cls isLoaded ifFalse:[cls autoload]]

    "Created: / 24-05-2008 / 01:55:31 / Jan Vrany <vranyj1@fel.cvut.cz>"
    "Modified: / 27-05-2008 / 07:41:29 / Jan Vrany <vranyj1@fel.cvut.cz>"
    "Modified: / 14-12-2010 / 11:07:25 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 10-06-2011 / 14:04:11 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

preLoadAction
    ProgressNotification autoload

!

preRequisites
    "list all required packages.
     This list can be maintained manually or (better) generated and
     updated by scanning the superclass hierarchies and looking for
     global variable accesses. (the browser has a menu function for that)
     Howevery, often too much is found, and you may want to explicitely
     exclude individual packages in the #excludedFromPrerequisites method."

    ^ #(

	#'stx:goodies/sunit'
	#'stx:goodies/xml/vw'    "XML::Node - referenced by SVN::WCEntry class>>readFromXml: "
	#'stx:libbasic'    "Object - superclass of SVN::MergeViewApp "
	#'stx:libbasic2'    "List - referenced by SVN::Configuration>>initialize "
	#'stx:libbasic3'    "ClassChange - superclass of extended MethodChange "
	#'stx:libtool'    "AbstractSettingsApplication - superclass of SVN::ConfigurationApp "
	#'stx:libtool2'    "MenuEditor - referenced by SVN::IconLibrary class>>initialize "
	#'stx:libview'    "GraphicsContext - superclass of SVN::DiffViewApp::Diff2TextView "
	#'stx:libview2'    "SimpleDialog - superclass of SVN::BranchSelectionDialog "
	#'stx:libwidg'    "Label - referenced by SVN::WorkingCopy>>inspector2TabBrowser "
	#'stx:libwidg2'    "TwoColumnTextView - superclass of SVN::DiffViewApp::Diff2TextView "
    )
!

preUnloadAction

    NewLauncher
	removeSettingsApplicationByClass: SVN::SettingsApp fullName asSymbol
! !

!stx_libsvn class methodsFor:'description - contents'!

classNamesAndAttributes
    "lists the classes which are to be included in the project.
     Each entry in the list may be: a single class-name (symbol),
     or an array-literal consisting of class name and attributes.
     Attributes are: #autoload or #<os> where os is one of win32, unix,..."

    ^ #(
	"<className> or (<className> attributes...) in load order"
	#'SVN::Branch'
	#'SVN::BranchQuery'
	#'SVN::Browser'
	#'SVN::Cache'
	#'SVN::CacheEntry'
	#'SVN::Command'
	(#'SVN::CommitTests' autoload)
	#'SVN::CompatModeQuery'
	#'SVN::Configuration'
	#'SVN::ConfigurationApp'
	(#'SVN::ConfigurationTests' autoload)
	#'SVN::Credentials'
	#'SVN::Dialog'
	#'SVN::DiffViewApp'
	#'SVN::Entry'
	#'SVN::Enum'
	#'SVN::ExternalMergeTool'
	#'SVN::IconLibrary'
	#'SVN::MergeBrowser'
	#'SVN::OSProcess'
	(#'SVN::PackageAResource' autoload)
	(#'SVN::PackageBResource' autoload)
	#'SVN::PackagePattern'
	(#'SVN::PackagePatternTests' autoload)
	(#'SVN::PackageResource' autoload)
	#'SVN::Property'
	#'SVN::Repository'
	#'SVN::RepositoryConfiguration'
	#'SVN::RepositoryManager'
	(#'SVN::RepositoryResource' autoload)
	#'SVN::Revision'
	#'SVN::SVNError'
	#'SVN::Task'
	(#'SVN::UpdateLikeWizard' autoload)
	#'SVN::WCAction'
	#'SVN::WCActionNotification'
	#'SVN::WCError'
	#'SVN::WizardPane'
	#'SVN::WorkingCopy'
	#'SVN::XMLObject'
	SVNSourceCodeManager
	#'stx_libsvn'
	#'SVN::AuthorizationError'
	#'SVN::BranchAndRevisionSelectionDialog'
	#'SVN::BranchCommand'
	#'SVN::BranchSelectionDialog'
	#'SVN::CVSTask'
	#'SVN::ConfigurationDialog'
	#'SVN::CreateRepositoryCommand'
	#'SVN::CredentialsDialog'
	#'SVN::FileoutLikeTask'
	#'SVN::KDiff3'
	#'SVN::MergeViewApp'
	#'SVN::NodeKind'
	#'SVN::NonExistentURLError'
	#'SVN::ProgressDialog'
	#'SVN::RepositoryDialog'
	#'SVN::RepositoryEntry'
	#'SVN::RevisionDate'
	#'SVN::RevisionHead'
	#'SVN::RevisionLogBrowser'
	#'SVN::RevisionLogEntry'
	#'SVN::RevisionNumber'
	#'SVN::Status'
	#'SVN::UnknownError'
	#'SVN::WCActionAdded'
	#'SVN::WCActionConflict'
	#'SVN::WCActionDeleted'
	#'SVN::WCActionMerged'
	#'SVN::WCActionModified'
	#'SVN::WCActionNone'
	#'SVN::WCActionRestored'
	#'SVN::WCActionUpdated'
	#'SVN::WCCommand'
	#'SVN::WCEntry'
	#'SVN::WCEntryInfo'
	#'SVN::Wizard'
	#'SVN::WorkingCopyBrowser'
	#'SVN::WorkingCopyLockedError'
	#'SVN::CatCommand'
	#'SVN::CleanupCommand'
	#'SVN::CommitTask'
	#'SVN::CommitWizard'
	#'SVN::CopyCommand'
	#'SVN::ImportFromCVSTask'
	#'SVN::ListCommand'
	#'SVN::LogCommand'
	#'SVN::MoveCommand'
	#'SVN::NodeKindDir'
	#'SVN::NodeKindExternal'
	#'SVN::NodeKindFile'
	#'SVN::NodeKindNone'
	#'SVN::NodeKindUnknown'
	#'SVN::StatusAdded'
	#'SVN::StatusConflicted'
	#'SVN::StatusDeleted'
	#'SVN::StatusExternal'
	#'SVN::StatusIgnored'
	#'SVN::StatusIncomplete'
	#'SVN::StatusMissing'
	#'SVN::StatusModified'
	#'SVN::StatusNormal'
	#'SVN::StatusObstructed'
	#'SVN::StatusReplaced'
	#'SVN::StatusUnversioned'
	#'SVN::SyncWithCVSTask'
	#'SVN::UpdateLikeCommand'
	#'SVN::UpdateLikeTask'
	#'SVN::WCPathCommand'
	#'SVN::AddCommand'
	#'SVN::CheckoutCommand'
	#'SVN::CommitCommand'
	#'SVN::DeleteCommand'
	#'SVN::InfoCommand'
	#'SVN::MergeCommand'
	#'SVN::MergeTask'
	#'SVN::PropsetCommand'
	#'SVN::ResolvedCommand'
	#'SVN::RevertCommand'
	#'SVN::StatusCommand'
	#'SVN::UpdateCommand'
	#'SVN::UpdateTask'
    )
!

extensionMethodNames
    "lists the extension methods which are to be included in the project.
     Entries are 2-element array literals, consisting of class-name and selector."

    ^ #(
	AbstractFileBrowser svnCommit
	AbstractFileBrowser svnStatus
	ChangeSet condenseChangesForPackage2:
	Class fileOutAsMethodIn:selector:
	Class svnBranch
	Class svnRepository
	Date asSVNRevisionSpec
	Filename directoryContentsAsFilenamesMatching:
	Filename directoryContentsMatching:
	FilenameWidgetWithHistory historyList:
	FilenameWidgetWithHistory modifiedChannel:
	Integer asSVNRevisionSpec
	Method makeSourceFileAbsolute
	MethodChange asAntiChange
	MethodChange isForGeneratedSubject
	String asSVNRevisionSpec
	#'Tools::NewSystemBrowser' classMenuDiffsetFor:againstBranch:revision:
	#'Tools::NewSystemBrowser' classMenuSubversionBrowseWorkingCopy
	#'Tools::NewSystemBrowser' classMenuSubversionChangeset
	#'Tools::NewSystemBrowser' classMenuSubversionChangeset:againstBranch:revision:
	#'Tools::NewSystemBrowser' classMenuSubversionCommit
	#'Tools::NewSystemBrowser' classMenuSubversionCompare
	#'Tools::NewSystemBrowser' classMenuSubversionCompare:withBranch:revision:
	#'Tools::NewSystemBrowser' classMenuSubversionCompare:withRevision:
	#'Tools::NewSystemBrowser' classMenuSubversionCompareWithRevisionHead
	#'Tools::NewSystemBrowser' classMenuSubversionUpdate
	#'Tools::NewSystemBrowser' classSubversionChangesetMenu
	#'Tools::NewSystemBrowser' commonMenuSubversionBrowseWorkingCopy
	#'Tools::NewSystemBrowser' commonMenuSubversionFlushCaches
	#'Tools::NewSystemBrowser' hasClassesSelectedAndSubversionRepositoryExistsAndBranchSelectedHolder
	#'Tools::NewSystemBrowser' hasProjectSelectedSubversionRepositoryExistsAndBranchSelectedHolder
	#'Tools::NewSystemBrowser' hasSingleClassAndSubversionRepositoryExists
	#'Tools::NewSystemBrowser' hasSubversionRepositoryAndBranchFor:
	#'Tools::NewSystemBrowser' projectMenuSubversionChangeset
	#'Tools::NewSystemBrowser' projectMenuSubversionChangesetAgainstBranch:revision:
	#'Tools::NewSystemBrowser' projectMenuSubversionCommit
	#'Tools::NewSystemBrowser' projectMenuSubversionCommitMode
	#'Tools::NewSystemBrowser' projectMenuSubversionCompare
	#'Tools::NewSystemBrowser' projectMenuSubversionCompareWithBranch:revision:
	#'Tools::NewSystemBrowser' projectMenuSubversionCompareWithRevisionHead
	#'Tools::NewSystemBrowser' projectMenuSubversionLoadRevision
	#'Tools::NewSystemBrowser' projectMenuSubversionLoadRevision:
	#'Tools::NewSystemBrowser' projectMenuSubversionMergeWith:revision:
	#'Tools::NewSystemBrowser' projectMenuSubversionRemoveWorkingCopy
	#'Tools::NewSystemBrowser' projectMenuSubversionShowRevisionLog
	#'Tools::NewSystemBrowser' projectMenuSubversionUpdate
	#'Tools::NewSystemBrowser' projectSubversionChangesetMenu
	#'Tools::NewSystemBrowser' projectSubversionMergeMenu
	#'Tools::NewSystemBrowser' selectedProjectSubversionRepository
	#'Tools::NewSystemBrowser' selectedProjectsForSubversion
	#'Tools::NewSystemBrowser' selectedProjectsFromClasses
	#'Tools::NewSystemBrowser' svnRepositoryFor:
	#'Tools::NewSystemBrowser' svnRepositoryManager
	#'Tools::NewSystemBrowser' theSingleSelectedProjectForSubversion
	#'Tools::NewSystemBrowser' theSingleSelectedProjectFromClasses
	UserPreferences svnConfigurations
	UserPreferences svnConfigurations2
	UserPreferences svnConfigurations2:
	UserPreferences svnConfigurations:
	UserPreferences svnCurrentConfiguration
	UserPreferences svnCurrentConfiguration:
	UserPreferences svnEnabled
	UserPreferences svnEnabled:
	UserPreferences svnVerbose
	UserPreferences svnVerbose:
	#'XML::NodeSet' #'@'
	'AbstractFileBrowser class' svnMenu
	'ProjectDefinition class' forEachContentsMethodsCodeToCompileDo:ignoreOldEntries:ignoreOldDefinition:
	'ProjectDefinition class' svnRepositoryUrl
	'ProjectDefinition class' #'svnRepositoryUrlString_code'
	'Tools::NewSystemBrowser class' classMenuSubversion
	'Tools::NewSystemBrowser class' classSubversionChangesetMenu
	'Tools::NewSystemBrowser class' classSubversionCompareMenu
	'Tools::NewSystemBrowser class' projectMenuSubversion
	'Tools::NewSystemBrowser class' projectSubversionChangesetMenu
	'Tools::NewSystemBrowser class' projectSubversionCompareMenu
	'Tools::NewSystemBrowser class' projectSubversionMergeMenu
	'UserNotification class' notify:progress:
    )
! !

!stx_libsvn class methodsFor:'description - project information'!

companyName
    "Return a companyname which will appear in <lib>.rc"

    ^ 'CTU-FEI'

    "Modified: / 06-04-2008 / 21:20:20 / janfrog"
!

description
    "Return a description string which will appear in vc.def / bc.def"

    ^ 'SubVersion support for Smalltalk/X'

    "Modified: / 06-04-2008 / 21:20:38 / janfrog"
!

legalCopyright
    "Return a copyright string which will appear in <lib>.rc"

    ^ 'Copyright Jan Vrany 2008'

    "Modified: / 06-04-2008 / 21:20:55 / janfrog"
!

productName
    "Return a product name which will appear in <lib>.rc"

    ^ 'Smalltalk/X Subversion support'

    "Modified: / 06-04-2008 / 21:21:14 / janfrog"
! !

!stx_libsvn class methodsFor:'description - svn'!

svnRepositoryUrlString
    "Return a SVN repository URL of myself.
     (Generated since 2011-04-08)
    "

    ^ '$URL$'
!

svnRevisionNr
    "Return a SVN revision number of myself.
     This number is updated after a commit"

    ^ "$SVN-Revision:"'372M'"$"
! !

!stx_libsvn class methodsFor:'loading'!

loadAsAutoloaded:asAutoloaded

    "Overriden to ease development. Bit tricky, since we have
     load libsvn from SVN while libsvn is not installed :-)"


    (Smalltalk commandLineArguments includes: '--libsvn-load-from-svn')
	ifTrue: [^self  loadAsAutoloadedFromRepository: asAutoloaded]
	ifFalse:[^super loadAsAutoloaded:asAutoloaded].

    "Created: / 24-11-2010 / 12:18:42 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

loadAsAutoloadedFromRepository: asAutoloaded

    | wc repo branch url i conf |

    "Checks"
    (OperatingSystem canExecuteCommand: 'svn') ifFalse:
	[^self error: 'command ''svn'' not found!!'].

    "Create a working copy"
		wc := (Filename homeDirectory / '.smalltalk' / 'working-copy' / UUID genUUID printString) .
		Smalltalk at:'#SVN::RepositoryManager:WorkingCopyBase' put: wc asString.
		[ wc recursiveMakeDirectory ] on: Error do:[:e|^self error:'cannot make working copy: ', e description].
		Smalltalk packagePath:
			(Smalltalk packagePath asOrderedCollection
			  addFirst: wc asString; yourself).

		"Determine repo and branch"
		repo := 'https://swing.fit.cvut.cz/svn/stx/libsvn'.
		branch := 'branches/v2'.
		i := Smalltalk commandLineArguments indexOf: '--libsvn-load-branch'.
		(i ~~ 0 and:[Smalltalk commandLineArguments size > i]) ifTrue:
			[branch := Smalltalk commandLineArguments at: i+1].

		"Checkout SVN from repository"
		url := repo , '/' , branch.
		self info:'Checking out from ', url , '...'.
		[ (wc / 'stx') makeDirectory ] on: Error do:[:e|^self error:'cannot make working copy: ', e description].
    (OperatingSystem executeCommand:('svn co %1 %2' bindWith: url with: (wc / 'stx' / 'libsvn' ) asString))
	ifFalse:[self error:'svn checkout failed'].

    "Reload from checked out directory:"
    self info:'Reloading...'.
    stx_libsvn removeFromSystem.
    Smalltalk commandLineArguments remove: '--libsvn-load-from-svn'.
    Smalltalk flushPathCaches.

    (Smalltalk loadPackage: 'stx:libsvn')
	ifFalse: [self error:'Cannot load libsvn'].

    conf := SVN::Configuration newRepository.
    conf package: self package; url: repo; branch: branch.
    SVN::Configuration current repositories addFirst: conf.

    "Created: / 24-11-2010 / 12:42:32 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 24-11-2010 / 15:14:03 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!stx_libsvn class methodsFor:'private'!

error: aString

    super error: ('libsvn [error]: ' , aString) "errorPrintCR".

    "Created: / 24-11-2010 / 12:50:57 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

info: aString

    ('libsvn [info]: ' , aString) errorPrintCR.

    "Created: / 24-11-2010 / 12:51:03 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!stx_libsvn class methodsFor:'documentation'!

version
    ^ '$Header$'
!

version_CVS
    ^ '$Header$'
!

version_SVN

    ^ 'Id: stx_libsvn.st 372 2011-09-29 10:47:58Z vranyj1 '
! !
